package deployment

import (
	"github.com/ankitrgadiya/operatorlib/pkg/interfaces"
	"github.com/ankitrgadiya/operatorlib/pkg/meta"
	"github.com/ankitrgadiya/operatorlib/pkg/pod"

	appsv1 "k8s.io/api/apps/v1"
)

// GenConfigMapFunc defines a function which generates ConfigMap.
type GenDeploymentFunc func(Conf) (*appsv1.Deployment, error)

// Conf is used to pass parameters to functions in this package to
// perform operations on Configmap objects.
type Conf struct {
	Meta     meta.Mutate
	Strategy appsv1.DeploymentStrategy
	GenDeploymentFunc
	Pod       pod.Mutate
	Object    *appsv1.Deployment
	Reconcile interfaces.Reconcile
	//	GenVolumesFunc         pod.GenVolumesFunc
	//	GenSecurityContextFunc pod.GenSecurityContextFunc
	//	GenRestartPolicyFunc   pod.GenRestartPolicyFunc
}
