package pvc

import (
	"github.com/ankitrgadiya/operatorlib/pkg/interfaces"
	"github.com/ankitrgadiya/operatorlib/pkg/meta"

	corev1 "k8s.io/api/core/v1"
)

type GenPVCFunc func(Conf) (*corev1.PersistentVolumeClaim, error)

type GenResourcesFunc func() (corev1.ResourceRequirements, error)
type GenAccessModesFunc func() ([]corev1.PersistentVolumeAccessMode, error)

type Conf struct {
	Meta      meta.Mutate
	Object    *corev1.PersistentVolumeClaim
	Reconcile interfaces.Reconcile
	GenPVCFunc
	StorageClassName *string
	GenResourcesFunc
	GenAccessModesFunc
}
